<script lang="ts">
  import { getBillOrderAPI } from "src/apis/get-bill-order";
  import { getCountAPI } from "src/apis/get-count";
  import { Collection } from "src/collectionFirebase";
  import { numberWithCommas } from "src/functions/comma-number";
  import { convertFullTime } from "src/functions/convert-time-th";
  import type { BillOrderModel } from "src/models/bill.order.type";
  import { Page } from "src/page";
  import { billOrderListStore, pageSelectedStore } from "src/store";
  import { onMount } from "svelte";

  let dataShowOnTable: BillOrderModel[] = [];
  let dataShowTop5: BillOrderModel[] = [];

  onMount(async () => {
    dataShowTop5 = [];
    await getBillOrderAPI();
    dataShowOnTable = $billOrderListStore?.length
      ? $billOrderListStore.sort(
          (a, b) =>
            +new Date(`${b?.createTime}`) - +new Date(`${a?.createTime}`)
        )
      : [];

    if (dataShowOnTable && dataShowOnTable.length > 0 && dataShowOnTable.length >= 5) {
      for (let i = 0; i < 5; i++) {
        dataShowTop5.push(dataShowOnTable[i]);
      }
      dataShowTop5 = dataShowTop5;
    } else if(dataShowOnTable && dataShowOnTable.length > 0 && dataShowOnTable.length < 5) {
      for (let i = 0; i < dataShowOnTable.length; i++) {
        dataShowTop5.push(dataShowOnTable[i]);
      }
      dataShowTop5 = dataShowTop5;
    }
  });

  function onSeeAll() {
    $pageSelectedStore = Page["BILL_ORDER"];
  }
</script>

<app-admin-navbar
  ><nav
    class="absolute top-0 left-0 w-full z-10 bg-transparent md:flex-row md:flex-nowrap md:justify-start flex items-center p-4"
  >
    <div
      class="w-full mx-autp items-center flex justify-between md:flex-nowrap flex-wrap md:px-10 px-4"
    >
      <div
        class="text-white text-sm uppercase hidden lg:inline-block font-semibold"
      >
        หน้าหลัก
      </div>
      <ul class="flex-col md:flex-row list-none items-center hidden md:flex">
        <app-user-dropdown class="block"
          ><a href="#pablo" class="text-blueGray-500 block"
            ><div class="items-center flex">
              <span
                class="w-12 h-12 text-sm text-white bg-blueGray-200 inline-flex items-center justify-center rounded-full"
                ><img
                  alt="..."
                  src="https://source.unsplash.com/user/erondu/900x900"
                  class="w-full rounded-full align-middle border-none shadow-lg"
                /></span
              >
            </div></a
          >
          <div
            class="min-w-48 z-50"
            data-popper-placement="bottom-end"
            style="position: absolute; inset: 0px auto auto 0px; margin: 0px; transform: translate(687px, 64px);"
          >
            <div
              class="bg-white text-base z-50 float-left py-2 list-none text-left rounded shadow-lg mt-1 min-w-48 hidden"
            >
              <a
                href="#pablo"
                class="text-sm py-2 px-4 font-normal block w-full whitespace-nowrap bg-transparent text-blueGray-700"
              >
                Action
              </a><a
                href="#pablo"
                class="text-sm py-2 px-4 font-normal block w-full whitespace-nowrap bg-transparent text-blueGray-700"
              >
                Another action
              </a><a
                href="#pablo"
                class="text-sm py-2 px-4 font-normal block w-full whitespace-nowrap bg-transparent text-blueGray-700"
              >
                Something else here
              </a>
              <div class="h-0 my-2 border border-solid border-blueGray-100" />
              <a
                href="#pablo"
                class="text-sm py-2 px-4 font-normal block w-full whitespace-nowrap bg-transparent text-blueGray-700"
              >
                Seprated link
              </a>
            </div>
          </div></app-user-dropdown
        >
      </ul>
    </div>
  </nav></app-admin-navbar
><app-header-stats class=""
  ><div class="relative bg-red-600 md:pt-32 pb-32 pt-12">
    <div class="px-4 md:px-10 mx-auto w-full">
      <div>
        <div class="flex flex-wrap">
          <div class="w-full lg:w-6/12 xl:w-4/12 px-4">
            <app-card-stats>
              <div
                class="relative flex flex-col min-w-0 break-words bg-white rounded mb-6 xl:mb-0 shadow-lg"
              >
                <div class="flex-auto p-4">
                  <div class="flex flex-wrap">
                    <div
                      class="relative w-full pr-4 max-w-full flex-grow flex-1"
                    >
                      <h5 class="text-blueGray-400 uppercase font-bold text-xs">
                        PRODUCTS
                      </h5>
                      <span class="font-semibold text-xl text-blueGray-700">
                        {#await getCountAPI(Collection["PRODUCTS"])}
                          <p>...Loading</p>
                        {:then number}
                          <p>{number} ชิ้น</p>
                        {:catch error}
                          <p style="color: red">{error.message}</p>
                        {/await}
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </app-card-stats>
          </div>
          <div class="w-full lg:w-6/12 xl:w-4/12 px-4">
            <app-card-stats>
              <div
                class="relative flex flex-col min-w-0 break-words bg-white rounded mb-6 xl:mb-0 shadow-lg"
              >
                <div class="flex-auto p-4">
                  <div class="flex flex-wrap">
                    <div
                      class="relative w-full pr-4 max-w-full flex-grow flex-1"
                    >
                      <h5 class="text-blueGray-400 uppercase font-bold text-xs">
                        USERS
                      </h5>
                      <span class="font-semibold text-xl text-blueGray-700">
                        {#await getCountAPI(Collection["USERS"])}
                          <p>...Loading</p>
                        {:then number}
                          <p>{number} คน</p>
                        {:catch error}
                          <p style="color: red">{error.message}</p>
                        {/await}
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </app-card-stats>
          </div>
          <div class="w-full lg:w-6/12 xl:w-4/12 px-4">
            <app-card-stats>
              <div
                class="relative flex flex-col min-w-0 break-words bg-white rounded mb-6 xl:mb-0 shadow-lg"
              >
                <div class="flex-auto p-4">
                  <div class="flex flex-wrap">
                    <div
                      class="relative w-full pr-4 max-w-full flex-grow flex-1"
                    >
                      <h5 class="text-blueGray-400 uppercase font-bold text-xs">
                        ORDERS
                      </h5>
                      <span class="font-semibold text-xl text-blueGray-700">
                        {#await getCountAPI(Collection["BILLORDERS"])}
                          <p>...Loading</p>
                        {:then number}
                          <p>{number} รายการ</p>
                        {:catch error}
                          <p style="color: red">{error.message}</p>
                        {/await}
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </app-card-stats>
          </div>
        </div>
      </div>
    </div>
  </div></app-header-stats
>
<div class="px-4 md:px-10 mx-auto w-full -m-24">
  <router-outlet /><app-dashboard class=""
    ><div class="flex flex-wrap w-full">
      <div class="flex flex-wrap mt-4 w-full">
        <div class="w-full mb-12 xl:mb-0 px-4">
          <div>
            <div
              class="relative flex flex-col min-w-0 break-words bg-white w-full mb-6 shadow-lg rounded"
            >
              <div class="rounded-t mb-0 px-4 py-3 border-0">
                <div class="flex flex-wrap items-center">
                  <div class="relative w-full px-4 max-w-full flex-grow flex-1">
                    <h3 class="font-semibold text-base text-blueGray-700">
                      รายการสั่งซื้อล่าสุด
                    </h3>
                  </div>
                  <div
                    class="relative w-full px-4 max-w-full flex-grow flex-1 text-right"
                  >
                    <button
                      on:click={onSeeAll}
                      type="button"
                      class="bg-indigo-500 text-white active:bg-indigo-600 text-xs font-bold uppercase px-3 py-1 rounded outline-none focus:outline-none mr-1 mb-1 ease-linear transition-all duration-150"
                    >
                      ดูทั้งหมด
                    </button>
                  </div>
                </div>
              </div>
              <div class="block w-full overflow-x-auto">
                <table
                  class="table-auto w-full overflow-y-auto overflow-x-auto border rounded text-sm"
                >
                  <thead class="bg-gray-100">
                    <tr>
                      <th class="px-4 py-2">#</th>
                      <th class="px-4 py-2">วัน/เวลา</th>
                      <th class="px-4 py-2">รหัสผู้ซื้อ</th>
                      <th class="px-4 py-2 truncate">รวมบิล</th>
                      <th class="px-4 py-2 ">ชำระเงิน</th>
                      <th class="px-4 py-2">ที่อยู่จัดส่ง</th>
                    </tr>
                  </thead>
                  {#if dataShowTop5?.length > 0}
                    {#each dataShowTop5 || [] as bill, index}
                      <tbody>
                        <tr class="bg-gray-100 hover:bg-gray-200">
                          <td class="border px-2 py-2 text-gray-800"
                            >{index + 1}</td
                          >
                          <td class="border truncate px-2 py-2 text-gray-800">
                            {bill?.createTime}
                          </td>
                          <td class="border px-2 py-2 text-gray-800"
                            >{bill?.userId}</td
                          >
                          <td
                            class="border px-2 py-2 overflow-x-hidden text-center font-bold text-green-600"
                          >
                            {numberWithCommas(bill?.sumPriceBill || 0) || "-"}
                          </td>
                          <td class="border p-2">
                            <p
                              class="rounded-full text-center text-white {bill?.statusPayment ==
                              'successful'
                                ? 'bg-green-600'
                                : 'bg-red-500'}"
                            >
                              {(bill?.statusPayment == "successful"
                                ? "Y"
                                : "N") || "-"}
                            </p>
                          </td>
                          <td
                            class="border px-2 py-2 text-gray-800 text-center"
                          >
                            <div class="flex">
                              <p
                                class="flex truncate justify-center border rounded w-full h-20 items-center"
                              >
                                {bill?.addressDelivery?.fullname}<br />
                                ที่อยู่: {bill?.addressDelivery?.address} ตำบล{bill
                                  ?.addressDelivery?.subdistrict} อำเภอ{bill
                                  ?.addressDelivery?.district} จังหวัด{bill
                                  ?.addressDelivery?.province}
                                <br />รหัสไปรษณีย์ {bill?.addressDelivery
                                  ?.zipcode}
                              </p>
                            </div>
                          </td>
                        </tr>
                      </tbody>
                    {/each}
                  {/if}
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div></app-dashboard
  ><!----><app-footer-admin
    ><footer class="block py-4">
      <div class="container mx-auto px-4">
        <hr class="mb-4 border-b-1 border-blueGray-200" />
        <div
          class="flex flex-wrap items-center md:justify-between justify-center"
        >
          <div class="w-full md:w-4/12 px-4">
            <div
              class="text-sm text-blueGray-500 font-semibold py-1 text-center md:text-left"
            >
              Copyright © 2021 <a
                href="https://www.creative-tim.com?ref=na-footer-admin"
                class="text-blueGray-500 hover:text-blueGray-700 text-sm font-semibold py-1"
              >
                Creative Tim
              </a>
            </div>
          </div>
          <div class="w-full md:w-8/12 px-4">
            <ul class="flex flex-wrap list-none md:justify-end justify-center">
              <li>
                <a
                  href="https://www.creative-tim.com?ref=na-footer-admin"
                  class="text-blueGray-600 hover:text-blueGray-800 text-sm font-semibold block py-1 px-3"
                >
                  Creative Tim
                </a>
              </li>
              <li>
                <a
                  href="https://www.creative-tim.com/presentation?ref=na-footer-admin"
                  class="text-blueGray-600 hover:text-blueGray-800 text-sm font-semibold block py-1 px-3"
                >
                  About Us
                </a>
              </li>
              <li>
                <a
                  href="http://blog.creative-tim.com?ref=na-footer-admin"
                  class="text-blueGray-600 hover:text-blueGray-800 text-sm font-semibold block py-1 px-3"
                >
                  Blog
                </a>
              </li>
              <li>
                <a
                  href="https://github.com/creativetimofficial/notus-angular/blob/main/LICENSE.md?ref=creativetim"
                  class="text-blueGray-600 hover:text-blueGray-800 text-sm font-semibold block py-1 px-3"
                >
                  MIT License
                </a>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </footer></app-footer-admin
  >
</div>
